declare function build(rootDir: string, stub: boolean): Promise<void>;

interface BuildEntry {
    input: string;
    name?: string;
    builder?: 'rollup' | 'mkdist' | 'untyped';
    format?: 'esm' | 'cjs';
    defaults?: Record<string, any>;
    declaration?: boolean;
    outDir?: string;
    ext?: 'mjs' | 'js' | 'ts';
}
interface BuildOptions {
    pkg: any;
    rootDir: string;
    declaration?: boolean;
    entries: BuildEntry[];
    clean: boolean;
    outDir: string;
    stub: boolean;
    dependencies: string[];
    devDependencies: string[];
    externals: string[];
    inlineDependencies: boolean;
}
interface BuildContext extends BuildOptions {
    buildEntries: {
        path: string;
        bytes?: number;
        exports?: string[];
        chunks?: string[];
    }[];
    usedImports: Set<string>;
}
interface BuildConfig extends Partial<Omit<BuildOptions, 'entries'>> {
    entries: (BuildEntry | string)[];
}
declare function defineBuildConfig(config: BuildConfig): BuildConfig;

export { BuildConfig, BuildContext, BuildEntry, BuildOptions, build, defineBuildConfig };
